Bug 47157 - Add keywords to libreoffice-*.desktop files in Linux
Summary: Add keywords to libreoffice-*.desktop files in Linux
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: LibreOffice (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: All Linux (All)
: low minor
Assignee: Marco Biscaro
QA Contact:
URL:
Whiteboard: BSA target:3.7.0 target:3.6.4
Keywords: difficultyBeginner, easyHack, skillScript, topicUI
Depends on:
Blocks:
 
Reported: 2012-03-09 07:37 UTC by Nicolas Delvaux
Modified: 2015-12-15 12:11 UTC (History)
4 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Nicolas Delvaux 2012-03-09 07:37:14 UTC
Originally filled at https://bugs.launchpad.net/ubuntu/+source/libreoffice/+bug/950834

The Desktop Entry Specification now provide a "Keywords" section.
Extract from the spec[1]:

"A list of strings which may be used in addition to other metadata to describe this entry. This can be useful e.g. to facilitate searching through entries."

This entry is used, for example, by Unity (Ubuntu default desktop) to find apps that the user search in a semantic way.

Here is my proposal (think as "if user search $keyword, he should find $app):
Writer: odt;docx;Text;Letter;CV;
Calc: ods;xls;xlsx;Accounting;Stats;Chart;
Impress: odp;ppt;pptx;Slide;Slideshow;Presentation;
Draw: odg;Vector;Schema;Diagram;
Math: Equation;
Base: Data;

It would also be cool to add words such as "Excel", "PowerPoint", etc. because they became kind of common nouns for some people. We may also add "Oracle", "MySQL", "PostgreSQL", etc. to Base.
But I don't know if it is doable because these words are trademarked.



[1] http://standards.freedesktop.org/desktop-entry-spec/latest/ar01s05.html#key-keywords
Comment 1 Nicolas Delvaux 2012-04-04 08:04:31 UTC
Keywords are not intended only for Unity: they also work, for example, with Gnome-Shell.
Comment 2 Björn Michaelsen 2012-06-10 04:25:15 UTC
confirming, prioritizing, easyhackifying.
code pointer:

http://opengrok.libreoffice.org/xref/core/sysui/desktop/menus/

see http://wiki.documentfoundation.org/Development/Easy_Hacks on how to proceed.
Comment 3 Marco Biscaro 2012-08-26 23:35:29 UTC
In progress.
Comment 4 Not Assigned 2012-08-27 10:16:47 UTC
Marco Biscaro committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=9d844ce3f8e411bfb4237372b1a6d4aec21a0a65

fdo#47157 adding Keywords to .desktop files
Comment 5 Björn Michaelsen 2012-08-27 10:21:53 UTC
please mark this resolved after sending the license statement as per:
 http://wiki.documentfoundation.org/Development/Developers
Comment 6 Nicolas Delvaux 2012-08-27 12:56:55 UTC
Was there any discussion about including keywords such as Word, Excel and Powerpoint?

Unfortunately, many users seem to be used to the Microsoft jargon.
So one may search for Excel when wanting to use a spreadsheet.

In fact, Word is not necessary because it is already in the "GenericName" entry (as "Word Processor"), so Writer will appear if one search for "Word".

The problem remains for Excel and PowerPoint.
However, "excel" is a common noun, so adding it should be fine.
And for PowerPoint, why not adding "point" and "power" (in this order if you prefer) ? These are both common nouns and users should just have to type the firsts letters (such as "pow") before finding Impress, so it should be enough.

What do you think?
Comment 7 Marco Biscaro 2012-08-27 14:26:18 UTC
@Björn Michaelsen: done!

@Nicolas Delvaux: I don't know if we can use Excel or PowerPoint in keywords: "Microsoft requires that its trademarks be used properly and under license, in appropriate circumstances."[1]

[1] http://www.microsoft.com/about/legal/en/us/IntellectualProperty/Trademarks/Usage/Office.aspx
Comment 8 Nicolas Delvaux 2012-08-29 09:24:18 UTC
@Marco Biscaro: I agree that we probably can't use "PowerPoint" and "Excel", that's why I proposed to use only common nouns as a workaround.

I really think we should find a solution to this (see my others comments).

Is there anyone with a legal background at the Document Foundation who could advise us?
Comment 9 sasha.libreoffice 2012-08-29 09:31:30 UTC
@ Alex
Greetings
Please, give advice to us here. See previous comment
Comment 10 Jeremy Bicha 2012-08-29 15:22:12 UTC
I strongly believe that Excel and PowerPoint should be listed as Keywords. LibreOffice does read and write Excel & PowerPoint files and someone looking for an app to do that on Linux should see LibreOffice as an option.

The use of the trademarks is for interoperability. Searching for Excel or PowerPoint in the GNOME Activities Overview or Unity's Dash currently doesn't turn up any results at all which doesn't seem right.
Comment 11 Jeremy Bicha 2012-08-29 15:23:40 UTC
Also, is this patch something that can be backported to the 3.6 series?
Comment 12 Marco Biscaro 2012-08-29 20:28:27 UTC
One question: we could (if there is no legal implications) add Excel to calc.desktop and PowerPoint to impress.desktop, because Calc and Impress are *compatible with* Excel and PowerPoint. Should we add Access to base.desktop and Visio to draw.desktop, since they are *alternatives to* Access and Visio (but not compatible with)?
Comment 13 Alex Thurgood 2012-08-31 14:05:48 UTC
(In reply to comment #9)
> @ Alex
> Greetings
> Please, give advice to us here. See previous comment

Hi ALL,

Ten years ago, this probably wouldn't have been high on many people's agendas. However, things have moved on, and caselaw has come in most countries, certainly those where LO is already used quite widely, where such use of trademarks could be considered to be problematic :

- under the "meta-tag", or "Google Adwords" doctrine approach, which has most notably been important in Europe ;

- under various trademark dilution doctrines ;

- actions tending to cause a mark to become generic despite the TM owner's indications/attempts to dissuade that (note that the MS page pointed to by Bjoern takes particular pains to tell users how to use the mark in order to avoid this problem, even though it may not be specifically mentioned).

So, my personal take on this would be to leave well alone and not use them.

Alex
Comment 14 Caolán McNamara 2012-10-31 20:57:04 UTC
Well if unity/gnome-shell additionally parsed the desktop mime-type record and split application/FOO and application/vnd.BAR.FOO to make FOO a search term then that'd be quite useful.

Anyway, lets leave this specific bug as "fixed" and file additional ones if necessary for extra search terms.
Comment 15 Not Assigned 2012-11-01 05:41:08 UTC
Marco Biscaro committed a patch related to this issue.
It has been pushed to "libreoffice-3-6":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=90524e0f8c6c7a8e6e5e8c0bc48afc2025336e63&g=libreoffice-3-6

fdo#47157 adding Keywords to .desktop files


It will be available in LibreOffice 3.6.4.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 16 Samuel Mehrbrodt (CIB) 2012-11-01 12:27:09 UTC
I have created another patch with more keywords at https://gerrit.libreoffice.org/#/c/953/ before I read Caolan's comment (#14).

I can't see any legal problem with using Microsoft trade names here. The trademarks policy (#7) speaks about user-visible text, not about Code.
Comment 17 Not Assigned 2012-11-07 14:38:15 UTC
Samuel Mehrbrodt committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=d8b07e5ba238d529a7610dd302269ee05c5e8fbc

fdo#47157 Add more keywords to .desktop files



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 18 Robinson Tryon (qubit) 2015-12-15 12:11:01 UTC
Migrating Whiteboard tags to Keywords: (EasyHack SkillScript DifficultyBeginner TopicUi )
[NinjaEdit]